#include "windows.h"
#include "math.h"
#include "resource.h"
#include "windowsx.h"
#include "stdio.h"
#include "fstream"
#include "iostream"


// Globals
  unsigned char buf[19]; // ausgabestring an comport mit den farbwerten
  unsigned char anfang[] = {255, 0, 0, 15, 255, 0, 0}; // 7 bytes anfangsstring fr ausgabe
  DWORD         iBytesWritten; // rckgabewert bei comausgabe
  DCB           dcb; // fr comport-parameter

  int           schleife; // zaehlschleife
  int           zaehl; // zaehlschleife
  int           zaehler;  // zaehlschleife
  int           histo = 0; // zaehlschleife

  float         RGB_R[4][121] = {0}; // R bis HSV-Wandlung
  float         RGB_G[4][121] = {0}; // G
  float         RGB_B[4][121] = {0}; // B

  float         RGB_R_aus[4] = {0}; // R nach HSV-Wandlung
  float         RGB_G_aus[4] = {0}; // G
  float         RGB_B_aus[4] = {0}; // B

  int           ergebnis_rgb_max = 0; // max rgb wert fr die rgb->hsv wandlung
  float         wert_rgb_min; // min rgb wert bei rgb->hsv wandlung
  float         wert_rgb_max; // max rgb wert bei rgb->hsv wandlung

  int           max_HSV_H[4] = {0}; // maximale anzahl an HSV_H werten in einem bereich
  int           HSV_S_histo[4][37]; // HSV_S wert berechnung
  int           HSV_V_max[4]; // maximale helligkeit bestimmung
  int           HSV_H_zaehl[4][37] = {0}; // HSV_H wert berechnung

  float         HSV_H[121][4]; // HSV-Werte
  float         HSV_S[121][4];
  float         HSV_V[121][4];

  int           bereich[4] = {0}; // bereichsermittlung von 0 - 359 in 36 schritten fr farbwerte

  int           Pixel_Wert[4] = {0}; // pixelwerte fr getpixel()
  int           ergebnis_max = 0; // maximal farbwert
  float         floor(float); // abrunden

  int           abfrageintervall = 500;  // einstellungswerte
  int           interpolationsschritte = 20;
  double        helligkeitsfaktor = 1.0;
  int           interpolationspause = 25;
  char          comport[] = "com1";
  int           Monitor = 0;
  int           PPK = 120; // Auszuwertende Pixel pro Kanal

  int           weiss_r = 255; // standardwerte fr weissabgleich
  int           weiss_g = 255;
  int           weiss_b = 255;

  int           weiss_r_set = 255; // standardwerte fr weissabgleich fr live-tv
  int           weiss_g_set = 255;
  int           weiss_b_set = 255;

  int           static_r = 255; // standardwert fr statische bildausgabe
  int           static_g = 255;
  int           static_b = 255;

  int           end_berechnung = 0; // variablen fr while-schleife zum thread beenden, wenn = 1
  int           end_ausgabe = 0;
  int           end_static = 0;
  int           end_weissabgleich = 0;

  int           res_x[2] = {0};
  int           res_y[2] = {0};
  int           pos_x[2] = {0};
  int           pos_y[2] = {0};

  int           Pixel[4][121][2]; // fr 4 Kanle 60 Werte fr x und y

  HANDLE        hCom= CreateFile (comport, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL); // comport ffnen

  HINSTANCE     g_hInstance;

  #define WM_TRAYMESSAGE WM_USER // frs trayicon 


  static VOID ShowNotifyIcon(HWND hDlg,BOOL bAdd) // Tray Icon Anzeigen/Ausblenden
{
  NOTIFYICONDATA nid;
  ZeroMemory(&nid,sizeof(nid));
  nid.cbSize=sizeof(NOTIFYICONDATA);
  nid.hWnd=hDlg;
  nid.uID=0;
  nid.uFlags=NIF_ICON | NIF_MESSAGE | NIF_TIP;
  nid.uCallbackMessage=WM_TRAYMESSAGE;
  nid.hIcon=LoadIcon(g_hInstance,MAKEINTRESOURCE(IDI_ICON1));
  lstrcpy(nid.szTip,TEXT("AtmoWin 0.2"));

  if( bAdd == TRUE )
    Shell_NotifyIcon(NIM_ADD,&nid);
  else
    Shell_NotifyIcon(NIM_DELETE,&nid);
}
 

void WriteReg(char * Name, char * Wert) // geht
  {
char buffer[60];
unsigned long size = sizeof(buffer);
strcpy(buffer, Wert);
HKEY software;
HKEY mykey;
RegCreateKey(HKEY_LOCAL_MACHINE,"Software\\AtmoWin",&software);
RegCreateKey(software,"AtmoWin",&mykey);
RegSetValueEx(mykey,Name,NULL,REG_SZ,(LPBYTE)buffer,size);
RegCloseKey(mykey);
RegCloseKey(software);
  }

void ReadReg(char * Name) // geht nicht :|
{
CHAR Wert = 0;
DWORD len; 
DWORD dwType; 
HKEY dmKey;
HKEY hkey;

// char sTemp[1024]; //value stored here
// char szSubKey[1024]; //Key to be read

len = sizeof(Wert);
RegOpenKeyEx( HKEY_LOCAL_MACHINE, "Software\\AtmoWin\\AtmoWin", 0, KEY_ALL_ACCESS, &dmKey ); 

RegQueryValueEx( dmKey, "abfrageintervall", 0, &dwType, (LPBYTE)Wert, &len ); 

}

void Weissabgleich()
  {
       dcb.DCBlength = sizeof(DCB);  // Laenge des Blockes MUSS gesetzt sein!
       GetCommState (hCom, &dcb);    // COM-Einstellungen holen und aendern
       dcb.BaudRate  = 38400;        // Baudrate
       dcb.ByteSize  = 8;            // Datenbits
       dcb.Parity    = NOPARITY;     // Paritt
       dcb.StopBits  = ONESTOPBIT;   // Stopbits
       SetCommState (hCom, &dcb);    // COM-Einstellungen speichern

	   while( end_weissabgleich == 0 ) 
	   {
	   		     memcpy(buf, &anfang,7); // Anfangsstring
				 memcpy( buf+7, &weiss_r,1); // R links
				 memcpy( buf+8, &weiss_g,1); // G links
				 memcpy( buf+9, &weiss_b,1); // B links
				 memcpy(buf+10, &weiss_r,1); // R rechts
				 memcpy(buf+11, &weiss_g,1); // G rechts
				 memcpy(buf+12, &weiss_b,1); // B rechts
				 memcpy(buf+13, &weiss_r,1); // R oben
				 memcpy(buf+14, &weiss_g,1); // G oben
				 memcpy(buf+15, &weiss_b,1); // B oben
				 memcpy(buf+16, &weiss_r,1); // R unten
				 memcpy(buf+17, &weiss_g,1); // G unten
				 memcpy(buf+18, &weiss_b,1); // B unten
				 
	             WriteFile (hCom, buf, 19, &iBytesWritten, NULL); // schicken an COM-Port
	             Sleep(100);
	   }
	ExitThread(0);
  }

void static_Ausgabe()
  {
       dcb.DCBlength = sizeof(DCB);  // Laenge des Blockes MUSS gesetzt sein!
       GetCommState (hCom, &dcb);    // COM-Einstellungen holen und aendern
       dcb.BaudRate  = 38400;        // Baudrate
       dcb.ByteSize  = 8;            // Datenbits
       dcb.Parity    = NOPARITY;     // Paritt
       dcb.StopBits  = ONESTOPBIT;   // Stopbits
       SetCommState (hCom, &dcb);    // COM-Einstellungen speichern

	   while( end_static == 0 ) 
	   {
	   		     memcpy(buf, &anfang,7); // Anfangsstring
				 memcpy( buf+7, &static_r,1); // R links
				 memcpy( buf+8, &static_g,1); // G links
				 memcpy( buf+9, &static_b,1); // B links
				 memcpy(buf+10, &static_r,1); // R rechts
				 memcpy(buf+11, &static_g,1); // G rechts
				 memcpy(buf+12, &static_b,1); // B rechts
				 memcpy(buf+13, &static_r,1); // R oben
				 memcpy(buf+14, &static_g,1); // G oben
				 memcpy(buf+15, &static_b,1); // B oben
				 memcpy(buf+16, &static_r,1); // R unten
				 memcpy(buf+17, &static_g,1); // G unten
				 memcpy(buf+18, &static_b,1); // B unten

	             WriteFile (hCom, buf, 19, &iBytesWritten, NULL); // schicken an COM-Port
	             Sleep(100);
	   }
	ExitThread(0);
  }

void Ausgabe()
 {
  int           s_1;  // zhlvariablen
  int			s_2;
  int			RGB_R_ausgabe[4]; // bernahme der ausgabewerte der berechnung damit es keine konflikte gibt
  int			RGB_G_ausgabe[4];
  int           RGB_B_ausgabe[4];
  float         interpolation_r[4] = {0}; // Differenz zw. 2 R/G/B werten zur Interpolation
  float         interpolation_g[4] = {0};
  float         interpolation_b[4] = {0};
  int           RGB_R_alt[4] = {0}; // alte werte fr linearinterpolation
  int           RGB_G_alt[4] = {0};
  int           RGB_B_alt[4] = {0};
  int           ausgabe_r[4] = {0}; // fertig berechnete ausgabewerte fr comport
  int           ausgabe_g[4] = {0};
  int           ausgabe_b[4] = {0}; 

  dcb.DCBlength = sizeof(DCB);  // Laenge des Blockes MUSS gesetzt sein!
  GetCommState (hCom, &dcb);    // COM-Einstellungen holen und aendern
  dcb.BaudRate  = 38400;        // Baudrate
  dcb.ByteSize  = 8;            // Datenbits
  dcb.Parity    = NOPARITY;     // Paritt
  dcb.StopBits  = ONESTOPBIT;   // Stopbits
  SetCommState (hCom, &dcb);    // COM-Einstellungen speichern

	while( end_ausgabe == 0 )
	{	
      for ( s_1 = 0; s_1 <= 3; s_1++ ) 
	   {
	      RGB_R_ausgabe[s_1] = RGB_R_aus[s_1] + ( weiss_r_set - 255 );
	      RGB_G_ausgabe[s_1] = RGB_G_aus[s_1] + ( weiss_g_set - 255 );
	      RGB_B_ausgabe[s_1] = RGB_B_aus[s_1] + ( weiss_b_set - 255 );

		  if ( RGB_R_ausgabe[s_1] > 255 ) { RGB_R_ausgabe[s_1] = 255; };
		  if ( RGB_G_ausgabe[s_1] > 255 ) { RGB_G_ausgabe[s_1] = 255; };
		  if ( RGB_B_ausgabe[s_1] > 255 ) { RGB_B_ausgabe[s_1] = 255; };

		  if ( RGB_R_ausgabe[s_1] < 0 ) { RGB_R_ausgabe[s_1] = 0; };
		  if ( RGB_G_ausgabe[s_1] < 0 ) { RGB_G_ausgabe[s_1] = 0; };
		  if ( RGB_B_ausgabe[s_1] < 0 ) { RGB_B_ausgabe[s_1] = 0; };

		  interpolation_r[s_1] = RGB_R_ausgabe[s_1] - RGB_R_alt[s_1];
          interpolation_g[s_1] = RGB_G_ausgabe[s_1] - RGB_G_alt[s_1];
          interpolation_b[s_1] = RGB_B_ausgabe[s_1] - RGB_B_alt[s_1];
	   }   
		  for ( s_2 = 0; s_2 < interpolationsschritte; s_2++ ) // anfang interpolation und ausgabe
	          {
                 ausgabe_r[0] = RGB_R_alt[0] + s_2 * ( interpolation_r[0] / interpolationsschritte );
		         ausgabe_g[0] = RGB_G_alt[0] + s_2 * ( interpolation_g[0] / interpolationsschritte );
				 ausgabe_b[0] = RGB_B_alt[0] + s_2 * ( interpolation_b[0] / interpolationsschritte );
				 ausgabe_r[1] = RGB_R_alt[1] + s_2 * ( interpolation_r[1] / interpolationsschritte );
		         ausgabe_g[1] = RGB_G_alt[1] + s_2 * ( interpolation_g[1] / interpolationsschritte );
				 ausgabe_b[1] = RGB_B_alt[1] + s_2 * ( interpolation_b[1] / interpolationsschritte );
				 ausgabe_r[2] = RGB_R_alt[2] + s_2 * ( interpolation_r[2] / interpolationsschritte );
		         ausgabe_g[2] = RGB_G_alt[2] + s_2 * ( interpolation_g[2] / interpolationsschritte );
				 ausgabe_b[2] = RGB_B_alt[2] + s_2 * ( interpolation_b[2] / interpolationsschritte );
				 ausgabe_r[3] = RGB_R_alt[3] + s_2 * ( interpolation_r[3] / interpolationsschritte );
		         ausgabe_g[3] = RGB_G_alt[3] + s_2 * ( interpolation_g[3] / interpolationsschritte );
				 ausgabe_b[3] = RGB_B_alt[3] + s_2 * ( interpolation_b[3] / interpolationsschritte );

				 memcpy(buf, &anfang,7); // Anfangsstring
				 memcpy( buf+7, &ausgabe_r[0],1); // R links
				 memcpy( buf+8, &ausgabe_g[0],1); // G links
				 memcpy( buf+9, &ausgabe_b[0],1); // B links
				 memcpy(buf+10, &ausgabe_r[1],1); // R rechts
				 memcpy(buf+11, &ausgabe_g[1],1); // G rechts
				 memcpy(buf+12, &ausgabe_b[1],1); // B rechts
				 memcpy(buf+13, &ausgabe_r[2],1); // R oben
				 memcpy(buf+14, &ausgabe_g[2],1); // G oben
				 memcpy(buf+15, &ausgabe_b[2],1); // B oben
				 memcpy(buf+16, &ausgabe_r[3],1); // R unten
				 memcpy(buf+17, &ausgabe_g[3],1); // G unten
				 memcpy(buf+18, &ausgabe_b[3],1); // B unten

				 WriteFile (hCom, buf, 19, &iBytesWritten, NULL); // schicken an COM-Port
				 Sleep(interpolationspause);
	          }	  
      for ( s_1 = 0; s_1 <= 3; s_1++ ) 
	   {
         RGB_R_alt[s_1] = RGB_R_ausgabe[s_1];
         RGB_G_alt[s_1] = RGB_G_ausgabe[s_1];
         RGB_B_alt[s_1] = RGB_B_ausgabe[s_1];
	   }
    } // while(1) ende
  ExitThread(0);
 }

void Pixelberechnung()
{

 while(1)
 {
	DISPLAY_DEVICE dd;
	dd.cb = sizeof(dd);
	DWORD dev = 0;
	int monitor = 0;

	while (EnumDisplayDevices(0, dev, &dd, 0))
	{
		if (!(dd.StateFlags & DISPLAY_DEVICE_MIRRORING_DRIVER))
		{
			DISPLAY_DEVICE ddMon;
			ZeroMemory(&ddMon, sizeof(ddMon));
			ddMon.cb = sizeof(ddMon);
			DWORD devMon = 0;

			while (EnumDisplayDevices(dd.DeviceName, devMon, &ddMon, 0))
			{
				if (ddMon.StateFlags & DISPLAY_DEVICE_ACTIVE)
					break;
				devMon++;
			}
			DEVMODE dm;
			ZeroMemory(&dm, sizeof(dm));
			dm.dmSize = sizeof(dm);
			if (EnumDisplaySettingsEx(dd.DeviceName, ENUM_CURRENT_SETTINGS, &dm, 0) == FALSE)
				EnumDisplaySettingsEx(dd.DeviceName, ENUM_REGISTRY_SETTINGS, &dm, 0);

		    res_x[monitor] = dm.dmPelsWidth;
	        res_y[monitor] = dm.dmPelsHeight;
			pos_x[monitor] = dm.dmPosition.x;
			pos_y[monitor] = dm.dmPosition.y;
		    monitor++;
		}
	  dev++;
	}

   // Pixelberechnung
    for ( zaehler = 1; zaehler <= PPK; zaehler++ ) { // Kanal 0 - links
		if ( zaehler <= PPK / 3 )                          { Pixel[0][zaehler][0] =     ( res_x[Monitor] / 20); }
		if ( zaehler <= 2 * PPK / 3 && zaehler > PPK / 3 ) { Pixel[0][zaehler][0] = 2 * ( res_x[Monitor] / 20); }
		if ( zaehler <= PPK && zaehler > 2 * PPK / 3 )     { Pixel[0][zaehler][0] = 3 * ( res_x[Monitor] / 20); }

		if ( zaehler <= PPK / 3 )                          { Pixel[0][zaehler][1] = ( zaehler +  1 )              * ( res_y[Monitor] / ( PPK / 3 + 2 ) ); }
	    if ( zaehler <= 2 * PPK / 3 && zaehler > PPK / 3 ) { Pixel[0][zaehler][1] = ( zaehler - PPK / 3 - 1 )     * ( res_y[Monitor] / ( PPK / 3 + 2 ) ); }
		if ( zaehler <= PPK && zaehler > 2 * PPK / 3 )     { Pixel[0][zaehler][1] = ( zaehler - 2 * PPK / 3 - 1 ) * ( res_y[Monitor] / ( PPK / 3 + 2 ) ); }
    }

    for ( zaehler = 1; zaehler <= PPK; zaehler++ ) { // Kanal 1 - rechts
		if ( zaehler <= PPK / 3 )                          { Pixel[1][zaehler][0] = 17 * ( res_x[Monitor] / 20); }
		if ( zaehler <= 2 * PPK / 3 && zaehler > PPK / 3 ) { Pixel[1][zaehler][0] = 18 * ( res_x[Monitor] / 20); }
		if ( zaehler <= PPK && zaehler > 2 * PPK / 3 )     { Pixel[1][zaehler][0] = 19 * ( res_x[Monitor] / 20); }

		if ( zaehler <= 20 )                               { Pixel[1][zaehler][1] = ( zaehler +  1 )              * ( res_y[Monitor] / ( PPK / 3 + 2 ) ); }
	    if ( zaehler <= 2 * PPK / 3 && zaehler > PPK / 3 ) { Pixel[1][zaehler][1] = ( zaehler - PPK / 3 - 1 )     * ( res_y[Monitor] / ( PPK / 3 + 2 ) ); }
		if ( zaehler <= PPK && zaehler > 2 * PPK / 3 )     { Pixel[1][zaehler][1] = ( zaehler - 2 * PPK / 3 - 1 ) * ( res_y[Monitor] / ( PPK / 3 + 2 ) ); }
    }

    for ( zaehler = 1; zaehler <= PPK; zaehler++ ) { // Kanal 2 - oben
		if ( zaehler <= PPK / 3 )                          { Pixel[2][zaehler][0] = ( zaehler +  1 )              * ( res_x[Monitor] / ( PPK / 3 + 2 ) ); }
		if ( zaehler <= 2 * PPK / 3 && zaehler > PPK / 3 ) { Pixel[2][zaehler][0] = ( zaehler - PPK / 3 - 1 )     * ( res_x[Monitor] / ( PPK / 3 + 2 ) ); }
		if ( zaehler <= PPK && zaehler > 2 * PPK / 3 )     { Pixel[2][zaehler][0] = ( zaehler - 2 * PPK / 3 - 1 ) * ( res_x[Monitor] / ( PPK / 3 + 2 ) ); }

		if ( zaehler <= PPK / 3 )                          { Pixel[2][zaehler][1] =     (res_y[Monitor] / 20); }
	    if ( zaehler <= 2 * PPK / 3 && zaehler > PPK / 3 ) { Pixel[2][zaehler][1] = 2 * (res_y[Monitor] / 20); }
		if ( zaehler <= PPK && zaehler > 2 * PPK / 3 )     { Pixel[2][zaehler][1] = 3 * (res_y[Monitor] / 20); }
    }

    for ( zaehler = 1; zaehler <= PPK; zaehler++ ) { // Kanal 3 - unten
		if ( zaehler <= PPK / 3 )                          { Pixel[3][zaehler][0] = ( zaehler +  1 )              * ( res_x[Monitor] / ( PPK / 3 + 2 ) ); }
		if ( zaehler <= 2 * PPK / 3 && zaehler > PPK / 3 ) { Pixel[3][zaehler][0] = ( zaehler - PPK / 3 - 1 )     * ( res_x[Monitor] / ( PPK / 3 + 2 ) ); }
		if ( zaehler <= PPK && zaehler > 2 * PPK / 3 )     { Pixel[3][zaehler][0] = ( zaehler - 2 * PPK / 3 - 1 ) * ( res_x[Monitor] / ( PPK / 3 + 2 ) ); }

		if ( zaehler <= PPK / 3 )                          { Pixel[3][zaehler][1] = 17 * (res_y[Monitor] / 20); }
	    if ( zaehler <= 2 * PPK / 3 && zaehler > PPK / 3 ) { Pixel[3][zaehler][1] = 18 * (res_y[Monitor] / 20); }
		if ( zaehler <= PPK && zaehler > 2 * PPK / 3 )     { Pixel[3][zaehler][1] = 19 * (res_y[Monitor] / 20); } 
    } 
  // Pixelberechnung Ende

  // Anzeigenaktualisierung der Auflsung
	  
	HWND hDlg = FindWindow(0, "AtmoWin 0.2");

	HWND hwnd10 = GetDlgItem (hDlg, IDC_STATIC1 );
	char res_static[255];
	wsprintf(res_static, ("%dx%d\r\n@%dx%d"), res_x[0], res_y[0], pos_x[0], pos_y[0]);
    Static_SetText(hwnd10, res_static);

	HWND hwnd11 = GetDlgItem (hDlg, IDC_STATIC2 );
    char res_static2[255];
	wsprintf(res_static2, ("%dx%d\r\n@%dx%d"), res_x[1], res_y[1], pos_x[1], pos_y[1]);
    Static_SetText(hwnd11, res_static2); 

	Sleep(7000);
 }

}

void Berechnung()
{

// lokae Variablen
float     HSV_H_fertig[4];
float     HSV_S_fertig[4];
float     HSV_V_fertig[4];

HDC hDC;
hDC = GetDC(NULL); 
HDC hMemDC = CreateCompatibleDC(hDC);

  while( end_berechnung == 0 ) // endlosschleife
  {
    HKEY hkey;
    DWORD dwLen, dwType, dwSize;
	LPBYTE lpData = 0;
	int reg[20] = {0};
	int count = 0;
	CHAR szString;

   HBITMAP hBitmap = CreateCompatibleBitmap(hDC, res_x[Monitor], res_y[Monitor]);
   SelectObject(hMemDC, hBitmap);
   BitBlt(hMemDC, 0, 0, res_x[Monitor], res_y[Monitor] , hDC, pos_x[Monitor], pos_y[Monitor], SRCCOPY);

   memset(HSV_H_zaehl, 0,sizeof(HSV_H_zaehl)); // HSV_H_zaehl Null setzen fr Histogramm
   memset(max_HSV_H, 0, sizeof(max_HSV_H)); // max H-Wert nach Histogramm aus 0 setzen
   memset(HSV_S_histo, 0, sizeof(HSV_S_histo));

    for (schleife = 1; schleife <= 120; schleife++) // bestimmung von PPK ( 120 ) punkten
	    {   
      for ( zaehl = 0; zaehl <= 3; zaehl++ ) // fr alle 4 kanle
		   {
             Pixel_Wert[zaehl] = GetPixel(hMemDC, Pixel[zaehl][schleife][0], Pixel[zaehl][schleife][1]); // pixelwerte auslesen

             RGB_R[zaehl][schleife] = GetRValue(Pixel_Wert[zaehl]); // R/G/B aus Pixelfarbwerten auslesen
             RGB_G[zaehl][schleife] = GetGValue(Pixel_Wert[zaehl]);
             RGB_B[zaehl][schleife] = GetBValue(Pixel_Wert[zaehl]);

	         // rgb - hsv wandlung anfang
             if ( RGB_R[zaehl][schleife] >= RGB_G[zaehl][schleife] ) { ergebnis_rgb_max = 1; wert_rgb_max = RGB_R[zaehl][schleife]; } else { ergebnis_rgb_max = 2; wert_rgb_max = RGB_G[zaehl][schleife]; }
             if ( RGB_B[zaehl][schleife] > wert_rgb_max  ) { ergebnis_rgb_max = 3; wert_rgb_max = RGB_B[zaehl][schleife]; } // max rgb wert bzw farbe

             if ( RGB_R[zaehl][schleife] > RGB_G[zaehl][schleife]  ) { wert_rgb_min = RGB_G[zaehl][schleife]; } else { wert_rgb_min = RGB_R[zaehl][schleife]; }
             if ( RGB_B[zaehl][schleife] < wert_rgb_min  ) { wert_rgb_min = RGB_B[zaehl][schleife]; } // min rgb wert
 
	         if ( wert_rgb_min == wert_rgb_max ) // Berechnung HSV_H
		        { HSV_H[schleife][zaehl] = 0; }
		     else
		        {
					if (ergebnis_rgb_max == 1) { HSV_H[schleife][zaehl] = 60 * (     ( (RGB_G[zaehl][schleife] - RGB_B[zaehl][schleife]) / (wert_rgb_max - wert_rgb_min) ));	}
					if (ergebnis_rgb_max == 2) { HSV_H[schleife][zaehl] = 60 * ( 2 + ( (RGB_B[zaehl][schleife] - RGB_R[zaehl][schleife]) / (wert_rgb_max - wert_rgb_min) ));	}
					if (ergebnis_rgb_max == 3) { HSV_H[schleife][zaehl] = 60 * ( 4 + ( (RGB_R[zaehl][schleife] - RGB_G[zaehl][schleife]) / (wert_rgb_max - wert_rgb_min) ));	}
		        }
             if ( HSV_H[schleife][zaehl] < 0 ) { HSV_H[schleife][zaehl] = HSV_H[schleife][zaehl] + 360; }

	         if ( wert_rgb_max == 0 ) { HSV_S[schleife][zaehl] = 0; } else { HSV_S[schleife][zaehl] =  100 * ( ( wert_rgb_max - wert_rgb_min ) / wert_rgb_max ); } // Berechnung HSV_S

             HSV_V[schleife][zaehl] = 100 * ( wert_rgb_max / 255 ); // Berechnung HSV_V
             // rgb - hsv wandlung ende
	     }
	} // schleife ende -> alle werte liegen als HSV vor


    for (schleife = 1; schleife <= 120; schleife++) // neue schleife
	    {   
      for ( zaehl = 0; zaehl <= 3; zaehl++ ) 
		   {
             // histogramm farbe anfang
		     for ( histo = 0; histo < 36; histo++ ) // aufteilung des h_wertes in 10 schritte
		        {
			      if ( HSV_H[schleife][zaehl] < (10 + (histo * 10)) && HSV_H[schleife][zaehl] >= ( histo * 10 ) ) 
			         { 
			            HSV_H_zaehl[zaehl][histo] = HSV_H_zaehl[zaehl][histo] + 1;
				        HSV_S_histo[zaehl][histo] = HSV_S_histo[zaehl][histo] + HSV_S[schleife][zaehl];
		             }  
		        }
	         for ( histo = 0; histo < 36; histo++ ) // suchen der maximalen werte in den 10 bereichen und speichern des bereichs
		        {
			       if ( histo == 0 ) 
			         { 
				        max_HSV_H[zaehl] = HSV_H_zaehl[zaehl][0]; 
				        bereich[zaehl] = 0;
			         }
			       if ( HSV_H_zaehl[zaehl][histo+1] > max_HSV_H[zaehl] )
			         { 
				        max_HSV_H[zaehl] = HSV_H_zaehl[zaehl][histo+1];
				        bereich[zaehl] = histo+1;
			         }
		        }
		    if ( max_HSV_H[zaehl] == 0 ) { HSV_S_fertig[zaehl] = 0; } else { HSV_S_fertig[zaehl] = HSV_S_histo[zaehl][bereich[zaehl]] / max_HSV_H[zaehl]; } // fertige sttigung
 
		    if ( schleife == 1 ) { HSV_V_max[zaehl] = HSV_V[1][zaehl]; } // Helligkeitsberechnung
	 	    else { if ( HSV_V[schleife][zaehl] > HSV_V_max[zaehl] ) {HSV_V_max[zaehl] = HSV_V[schleife][zaehl]; } }	 
	        // histogramm farbe ende
	      }
	 } // schleife ende



   for ( zaehl = 0; zaehl <= 3; zaehl++ ) // rckrechnung der fertigen ausgabewerte von HSV in RGB
      {
		HSV_H_fertig[zaehl] = bereich[zaehl]*10; // fertiger farbton
	    HSV_V_fertig[zaehl] = HSV_V_max[zaehl]*helligkeitsfaktor;  // fertige helligkeit incl helligkeitsfaktorverrechnung
		if ( HSV_V_fertig[zaehl] > 100 ) { HSV_V_fertig[zaehl] = 100; }


         // hsv - rgb wandlung anfang
	 	 if ( HSV_S_fertig[zaehl] == 0 ) { RGB_R_aus[zaehl] = HSV_V_fertig[zaehl] * 255/100; RGB_G_aus[zaehl] = HSV_V_fertig[zaehl] * 255/100; RGB_B_aus[zaehl] = HSV_V_fertig[zaehl] * 255/100; } // falls farbe grau-schwarz-weiss
	 	 else {
			 float HSV_H_i = floor(HSV_H_fertig[zaehl]/60); // vorkommastelle
             float HSV_RGB_f = ( HSV_H_fertig[zaehl] / 60 ) - HSV_H_i; // nachkommastellen
			 float HSV_RGB_p = ( HSV_V_fertig[zaehl] / 100 ) * ( 100 -   HSV_S_fertig[zaehl] );
			 float HSV_RGB_q = ( HSV_V_fertig[zaehl] / 100 ) * ( 100 - ( HSV_S_fertig[zaehl] * HSV_RGB_f ));
			 float HSV_RGB_t = ( HSV_V_fertig[zaehl] / 100 ) * ( 100 - ( HSV_S_fertig[zaehl] * ( 1 - HSV_RGB_f )));

			 if ( HSV_H_i == 0 ) { RGB_R_aus[zaehl] = HSV_V_fertig[zaehl] * 255/100; RGB_G_aus[zaehl] = HSV_RGB_t * 255/100;           RGB_B_aus[zaehl] = HSV_RGB_p * 255/100; }
			 if ( HSV_H_i == 1 ) { RGB_R_aus[zaehl] = HSV_RGB_q * 255/100;           RGB_G_aus[zaehl] = HSV_V_fertig[zaehl] * 255/100; RGB_B_aus[zaehl] = HSV_RGB_p * 255/100; }
			 if ( HSV_H_i == 2 ) { RGB_R_aus[zaehl] = HSV_RGB_p * 255/100;           RGB_G_aus[zaehl] = HSV_V_fertig[zaehl] * 255/100; RGB_B_aus[zaehl] = HSV_RGB_t * 255/100; }
			 if ( HSV_H_i == 3 ) { RGB_R_aus[zaehl] = HSV_RGB_p * 255/100;           RGB_G_aus[zaehl] = HSV_RGB_q * 255/100;           RGB_B_aus[zaehl] =     HSV_V_fertig[zaehl] * 255/100; }
			 if ( HSV_H_i == 4 ) { RGB_R_aus[zaehl] = HSV_RGB_t * 255/100;           RGB_G_aus[zaehl] = HSV_RGB_p * 255/100;           RGB_B_aus[zaehl] =     HSV_V_fertig[zaehl] * 255/100; }
			 if ( HSV_H_i == 5 ) { RGB_R_aus[zaehl] = HSV_V_fertig[zaehl] * 255/100; RGB_G_aus[zaehl] = HSV_RGB_p * 255/100;           RGB_B_aus[zaehl] = HSV_RGB_q * 255/100; }
		     } 
	     // hsv - rgb wandlung ende
       }


   Sleep(abfrageintervall);

 } // while(1) ende

DeleteDC(hMemDC);
ReleaseDC(NULL, hDC);
ExitThread(0);

}

BOOL CALLBACK DialogProc2(HWND hDlg2, UINT uMsg2, WPARAM wParam2, LPARAM lParam2) // Weissabgleich Fenster
{
	switch(uMsg2)
	{
	case WM_INITDIALOG:
		{
			DWORD id7;
			CreateThread(0, 0, (LPTHREAD_START_ROUTINE)Weissabgleich, 0, 0, &id7); // weissabgleich thread

			HWND hwnd3 = GetDlgItem (hDlg2, IDC_EDIT1);
            char weiss_r_char[255];
			wsprintf(weiss_r_char, "%d", weiss_r);
            Edit_SetText(hwnd3, weiss_r_char);

			HWND hwnd4 = GetDlgItem (hDlg2, IDC_EDIT2);
            char weiss_g_char[255];
			wsprintf(weiss_g_char, "%d", weiss_g);
            Edit_SetText(hwnd4, weiss_g_char);

			HWND hwnd5 = GetDlgItem (hDlg2, IDC_EDIT3);
            char weiss_b_char[255];
			wsprintf(weiss_b_char, "%d", weiss_b);
            Edit_SetText(hwnd5, weiss_b_char);

			return FALSE;
		}

	case WM_COMMAND:
		{
			switch(LOWORD(wParam2))
			{

			case IDC_EDIT1:
				{
				HWND hwnd3 = GetDlgItem (hDlg2, IDC_EDIT1);
				char r_spei[255];
				Edit_GetText (hwnd3,r_spei,255);
				weiss_r = atoi(r_spei);

				return FALSE;
				}

			case IDC_EDIT2:
				{
				HWND hwnd4 = GetDlgItem (hDlg2, IDC_EDIT2);
				char g_spei[255];
				Edit_GetText (hwnd4,g_spei,255);
				weiss_g = atoi(g_spei);

				return FALSE;
				}

			case IDC_EDIT3:
				{
				HWND hwnd5 = GetDlgItem (hDlg2, IDC_EDIT3);
				char b_spei[255];
				Edit_GetText (hwnd5,b_spei,255);
				weiss_b = atoi(b_spei);

				return FALSE;
				}

			case IDOK:  // beenden
				{
				weiss_r_set = weiss_r;
				weiss_g_set = weiss_g;
				weiss_b_set = weiss_b;

				end_berechnung = 0;
				end_ausgabe = 0;
				end_static = 1;
				end_weissabgleich = 1;

				DWORD id1;
				CreateThread(0, 0, (LPTHREAD_START_ROUTINE)Berechnung, 0, 0, &id1); // Thread zur Berechnung

				DWORD id2;
				CreateThread(0, 0, (LPTHREAD_START_ROUTINE)Ausgabe, 0, 0, &id2); // Thread zur seriellen Ausgabe

				EndDialog(hDlg2, 1);
				return FALSE;
				}

			case IDCANCEL: // x-button -> beenden
				{

				weiss_r = weiss_r_set;
				weiss_g = weiss_g_set;
				weiss_b = weiss_b_set;

				end_berechnung = 0;
				end_ausgabe = 0;
				end_static = 1;
				end_weissabgleich = 1;

				DWORD id1;
				CreateThread(0, 0, (LPTHREAD_START_ROUTINE)Berechnung, 0, 0, &id1); // Thread zur Berechnung

				DWORD id2;
				CreateThread(0, 0, (LPTHREAD_START_ROUTINE)Ausgabe, 0, 0, &id2); // Thread zur seriellen Ausgabe

				EndDialog(hDlg2, 1);
				return FALSE;
				}
			}
		}
	}
	return FALSE;
}

BOOL CALLBACK DialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) // MainWindow
{
	switch(uMsg)
	{
	case WM_INITDIALOG:
		{
			HWND hwnd2 = GetDlgItem (hDlg, IDC_COMBO2);
			ComboBox_AddString(hwnd2, "com1");
			ComboBox_AddString(hwnd2, "com2");
			ComboBox_AddString(hwnd2, "com3");
			ComboBox_AddString(hwnd2, "com4"); 
			ComboBox_SetCurSel(hwnd2,0);
            
			HWND hwnd3 = GetDlgItem (hDlg, IDC_EDIT2);
            char ab_int[255];
			wsprintf(ab_int, "%d", abfrageintervall);
            Edit_SetText(hwnd3, ab_int);

			HWND hwnd4 = GetDlgItem (hDlg, IDC_EDIT3);
            char int_schritt[255];
			wsprintf(int_schritt, "%d", interpolationsschritte);
            Edit_SetText(hwnd4, int_schritt);

			HWND hwnd5 = GetDlgItem (hDlg, IDC_EDIT4);
            char h_fak[255];
			sprintf(h_fak, "%G", helligkeitsfaktor);
            Edit_SetText(hwnd5, h_fak);

			HWND hwnd6 = GetDlgItem (hDlg, IDC_EDIT5);
            char int_pause[255];
			wsprintf(int_pause, "%d", interpolationspause);
            Edit_SetText(hwnd6, int_pause);

			HWND hwnd7 = GetDlgItem (hDlg, IDC_EDIT1);
			char int_r[255] = "255";
			Edit_SetText(hwnd7, int_r);

			HWND hwnd8 = GetDlgItem (hDlg, IDC_EDIT6);
			char int_g[255] = "255";
			Edit_SetText(hwnd8, int_g);

			HWND hwnd9 = GetDlgItem (hDlg, IDC_EDIT7);
			char int_b[255] = "255";
			Edit_SetText(hwnd9, int_b);

			HWND hwnd10 = GetDlgItem (hDlg, IDC_STATIC1 );
            char res_static[255];
			wsprintf(res_static, ("%dx%d\r\n@%dx%d"), res_x[0], res_y[0], pos_x[0], pos_y[0]);
            Static_SetText(hwnd10, res_static);

			HWND hwnd11 = GetDlgItem (hDlg, IDC_STATIC2 );
            char res_static2[255];
			wsprintf(res_static2, ("%dx%d\r\n@%dx%d"), res_x[1], res_y[1], pos_x[1], pos_y[1]);
            Static_SetText(hwnd11, res_static2);

			if ( Monitor == 0 ) 
			{
			HWND hwnd12 = GetDlgItem (hDlg, IDC_RADIO1 );
			SendMessage(hwnd12, BM_SETCHECK, BST_CHECKED, 0); // Radio1 aktiviert
			}

			if ( Monitor == 1 ) 
			{
			HWND hwnd13 = GetDlgItem (hDlg, IDC_RADIO2 );
			SendMessage(hwnd13, BM_SETCHECK, BST_CHECKED, 0); // Radio1 aktiviert
			}

            return FALSE;
		}

     case WM_SYSCOMMAND:
		{
         if( wParam == SC_MINIMIZE )
           {
	        ShowWindow(hDlg,SW_HIDE);
         	ShowNotifyIcon(hDlg,TRUE);
	        SetWindowLong(hDlg,DWL_MSGRESULT,0); // WM_SYSCOMMAND gehandelt
		    return TRUE; // Nachricht gehandelt 
           }
		} 

    case WM_TRAYMESSAGE:
       switch(lParam)
        {
	      case WM_LBUTTONDBLCLK:
		     {
				ShowNotifyIcon(hDlg,FALSE);
                ShowWindow(hDlg,SW_SHOW);
				SetActiveWindow(hDlg);
                SetForegroundWindow(hDlg);
	         }
	   return FALSE;
	   }

	case WM_COMMAND:
		{
		  switch(LOWORD(wParam))
			{

			case IDC_BUTTON4:  // beenden
				{
					// beim beenden setzen aller ausgabewerte auf 0
				   static_r = 0;
				   static_g = 0;
				   static_b = 0;
				   end_berechnung = 1;
				   end_ausgabe = 1;
				   end_weissabgleich = 1;
				   end_static = 0;
				   DWORD id2;
				   Sleep(100);
				   CreateThread(0, 0, (LPTHREAD_START_ROUTINE)static_Ausgabe, 0, 0, &id2); // Thread zur seriellen Ausgabe
				   EndDialog(hDlg, 1);
				   return FALSE;
				}

			case IDCANCEL: // x-button -> beenden
				{
					// beim beenden setzen aller ausgabewerte auf 0
				   static_r = 0;
				   static_g = 0;
				   static_b = 0;
				   end_berechnung = 1;
				   end_ausgabe = 1;
				   end_weissabgleich = 1;
				   end_static = 0;
				   DWORD id2;
				   Sleep(100);
				   CreateThread(0, 0, (LPTHREAD_START_ROUTINE)static_Ausgabe, 0, 0, &id2); 
				   EndDialog(hDlg, 1);
				   return FALSE;
				}

			case IDC_EDIT1:
				{
					HWND hwnd7 = GetDlgItem (hDlg, IDC_EDIT1);
			     	char r_les[255];
				    Edit_GetText (hwnd7,r_les,255);
				    static_r = atoi(r_les);

					HWND hwnd8 = GetDlgItem (hDlg, IDC_EDIT6);
			     	char g_les[255];
				    Edit_GetText (hwnd8,g_les,255);
				    static_g = atoi(g_les);

					HWND hwnd9 = GetDlgItem (hDlg, IDC_EDIT7);
			     	char b_les[255];
				    Edit_GetText (hwnd9,b_les,255);
				    static_b = atoi(b_les);

					return FALSE;
				}

			case IDC_EDIT6:
				{
					HWND hwnd7 = GetDlgItem (hDlg, IDC_EDIT1);
			     	char r_les[255];
				    Edit_GetText (hwnd7,r_les,255);
				    static_r = atoi(r_les);

					HWND hwnd8 = GetDlgItem (hDlg, IDC_EDIT6);
			     	char g_les[255];
				    Edit_GetText (hwnd8,g_les,255);
				    static_g = atoi(g_les);

					HWND hwnd9 = GetDlgItem (hDlg, IDC_EDIT7);
			     	char b_les[255];
				    Edit_GetText (hwnd9,b_les,255);
				    static_b = atoi(b_les);

					return FALSE;
				}

			case IDC_EDIT7:
				{
					HWND hwnd7 = GetDlgItem (hDlg, IDC_EDIT1);
			     	char r_les[255];
				    Edit_GetText (hwnd7,r_les,255);
				    static_r = atoi(r_les);

					HWND hwnd8 = GetDlgItem (hDlg, IDC_EDIT6);
			     	char g_les[255];
				    Edit_GetText (hwnd8,g_les,255);
				    static_g = atoi(g_les);

					HWND hwnd9 = GetDlgItem (hDlg, IDC_EDIT7);
			     	char b_les[255];
				    Edit_GetText (hwnd9,b_les,255);
				    static_b = atoi(b_les);

					return FALSE;
				}

			case IDC_BUTTON1: // weissabgleich
				{
				end_berechnung = 1;
				end_ausgabe = 1;
				end_static = 1;
				end_weissabgleich = 0;

				HINSTANCE hInstance2 = GetModuleHandle(0);
                DialogBox(hInstance2, MAKEINTRESOURCE(IDD_DIALOG2), NULL, DialogProc2);

				return FALSE;
				}

			case IDC_CHECK1: // manuelle farbe
				{
                   HWND hwnd2 = GetDlgItem (hDlg, IDC_CHECK1);
				   int button_checked = Button_GetCheck(hwnd2);

				   if ( button_checked == 0 ) 
				      {
					     end_berechnung = 0; 
					     end_ausgabe = 0;
					     end_weissabgleich = 1;
					     end_static = 1;
						 Sleep(150);

					     DWORD id1;
					     CreateThread(0, 0, (LPTHREAD_START_ROUTINE)Berechnung, 0, 0, &id1); // Thread zur Berechnung

					     DWORD id2;
					     CreateThread(0, 0, (LPTHREAD_START_ROUTINE)Ausgabe, 0, 0, &id2); // Thread zur seriellen Ausgabe
				      }
				   if ( button_checked == 1 )
				      { 
					     end_berechnung = 1;
					     end_ausgabe = 1;
					     end_weissabgleich = 1;
					     end_static = 0;
					     Sleep(150);

					     DWORD id2;
					     CreateThread(0, 0, (LPTHREAD_START_ROUTINE)static_Ausgabe, 0, 0, &id2); // Thread zur seriellen Ausgabe
				      }
				   return FALSE;
				}

			case IDC_BUTTON2: // einstellungen bernehmen
				{
			    	HWND hwnd2 = GetDlgItem (hDlg, IDC_COMBO2);
				    int combo_cur = ComboBox_GetCurSel(hwnd2);
					if ( combo_cur == 0 ) { strcpy(comport, "com1"); }
					if ( combo_cur == 1 ) { strcpy(comport, "com2"); }
					if ( combo_cur == 2 ) { strcpy(comport, "com3"); }
					if ( combo_cur == 3 ) { strcpy(comport, "com4"); }
					CloseHandle (hCom);
					HANDLE hCom = CreateFile (comport, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);

					HWND hwnd3 = GetDlgItem (hDlg, IDC_EDIT2);
					char ab_les[255];
					Edit_GetText (hwnd3,ab_les,255);
					abfrageintervall = atoi(ab_les);

					HWND hwnd4 = GetDlgItem (hDlg, IDC_EDIT3);
					char int_aus[255];
					Edit_GetText (hwnd4,int_aus,255);
					interpolationsschritte = atoi(int_aus);

					HWND hwnd5 = GetDlgItem (hDlg, IDC_EDIT4);
					char hell_aus[255];
					Edit_GetText (hwnd5,hell_aus,255);
					helligkeitsfaktor = atof(hell_aus);

					HWND hwnd6 = GetDlgItem (hDlg, IDC_EDIT5);
					char intp_aus[255];
					Edit_GetText (hwnd6,intp_aus,255);
					interpolationspause = atoi(intp_aus);

					MessageBox(hDlg, "Einstellungen bernommen", "AtmoWin", MB_OK);

					return FALSE;
				}

			case IDC_BUTTON3:
				{
					HWND hwnd2 = GetDlgItem (hDlg, IDC_COMBO2);
					ComboBox_SetCurSel(hwnd2,0);
            
					HWND hwnd3 = GetDlgItem (hDlg, IDC_EDIT2);
					char ab_int[255];
					wsprintf(ab_int, "%d", abfrageintervall);
					Edit_SetText(hwnd3, ab_int);
	
					HWND hwnd4 = GetDlgItem (hDlg, IDC_EDIT3);
					char int_schritt[255];
					wsprintf(int_schritt, "%d", interpolationsschritte);
					Edit_SetText(hwnd4, int_schritt);

					HWND hwnd5 = GetDlgItem (hDlg, IDC_EDIT4);
					char h_fak[255];
					sprintf(h_fak, "%G", helligkeitsfaktor);
					Edit_SetText(hwnd5, h_fak);

					HWND hwnd6 = GetDlgItem (hDlg, IDC_EDIT5);
					char int_pause[255];
					wsprintf(int_pause, "%d", interpolationspause);
					Edit_SetText(hwnd6, int_pause);

					return FALSE;
				}

			case IDC_RADIO1:
				{
                    Monitor = 0;
					return FALSE;
				}

			case IDC_RADIO2:
				{
					Monitor = 1;
					return FALSE;
				}
			}
		}
	}
 return FALSE;
}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrev, LPSTR lpCmdLine, int nShowCmd)
{ 
  g_hInstance = hInstance;

  /*  char aus_char[255]; 
  wsprintf(aus_char, "%d", abfrageintervall);
  WriteReg("abfrageintervall",aus_char); 

  ReadReg("abfrageintervall"); */

  DWORD id0;
  CreateThread(0, 0, (LPTHREAD_START_ROUTINE)Pixelberechnung, 0, 0, &id0); // Thread zur Pixelberechnung

  DWORD id1;
  CreateThread(0, 0, (LPTHREAD_START_ROUTINE)Berechnung, 0, 0, &id1); // Thread zur Berechnung

  DWORD id2;
  CreateThread(0, 0, (LPTHREAD_START_ROUTINE)Ausgabe, 0, 0, &id2); // Thread zur seriellen Ausgabe

  int ret = DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), NULL, DialogProc);
 
  CloseHandle (hCom); // COM schlieen
  return true;
}